#!/usr/bin/perl -w
#
# Parse files containing line like:
# err iMsg=1 iter=28209379 i=0 0x8400f1f3_8401c1b3_84024df3_84032db3 0x2400f1f3_240141f3_24024df3_24032db3 ...

use strict;
use FileHandle;
use File::Basename;
use lib(dirname($0));
use pattern5;

my $inFile = $ARGV[0];

open(IN, "< $inFile") || die "Failed to open \"$inFile\" for reading\n";
while (<IN>) {
  next unless /^\s*err/;
  if (/^\s*err\s+(iMsg.*i=\d+)\s+0x([0-9a-f_]+)\s+0x([0-9a-f_]+)/) {
    my $str = $1;
    my $rx  = Pattern5->new(split /_/, $2);
    my $tx  = Pattern5->new(split /_/, $3);
    printf "%s | %s %d %d %d %d %d | %s %d %d %d %d %d\n",
           $str,
           $rx->{tx}->as_string, $rx->{ch}, $rx->{iter}, $rx->{iMsg}, $rx->{a128}->[0], $rx->{a16}->[0],
           $tx->{tx}->as_string, $tx->{ch}, $tx->{iter}, $tx->{iMsg}, $tx->{a128}->[0], $tx->{a16}->[0];
  }
}
close(IN);
