# =============
# QPACE/TNWTEST
# =============
# $Id: intf.pm 3149 2010-02-03 18:17:22Z pleiter $
#---------------------------------------------------------------------------------------------------

package Intf;

use strict;


#---------------------------------------------------------------------------------------------------
# Constructor
#---------------------------------------------------------------------------------------------------

sub new
{
  my $class = shift;
  my @argv  = @_;

  my $self     = {};
  $self->{phy} = undef;
  $self->{pr}  = undef;

  if (scalar @argv == 1) {	# expect PHY number
    $self->{phy} = $argv[0];
  }
  elsif (scalar @argv == 2) {	# expect PHY number and interface
    $self->{phy} = $argv[0];
    $self->{pr}  = $argv[1];
  }

  unless (defined $self->{phy}) {
    die "Contructor for class Intf failed";
  }
  unless (0 <= $self->{phy} && $self->{phy} <= 5) {
    die "Contructor for class Intf failed";
  }
  if (defined $self->{pr} && ($self->{pr} ne "p" && $self->{pr} ne "r")) {
    die "Contructor for class Intf failed (", join(", ", @argv), ")";
  }

  bless ($self, $class);
  return $self;
}


#---------------------------------------------------------------------------------------------------
# Member functions
#---------------------------------------------------------------------------------------------------

sub as_string
{
  my $self = shift;
  return (defined $self->{pr}) ?
         sprintf "%d%s", $self->{phy}, $self->{pr} :
         sprintf "%d", $self->{phy};
}

1;
