# =============
# QPACE/TNWTEST
# =============
# $Id: io.pm 3171 2010-02-06 19:03:34Z pleiter $
#---------------------------------------------------------------------------------------------------

package io;

use strict;

use lib("$ENV{QRUNDIR}/pm");
use defs qw($opt_v);


#---------------------------------------------------------------------------------------------------
# Output interface
#---------------------------------------------------------------------------------------------------

sub fprLog
{
  _fout("log", @_);
}

sub prLog
{
  _out("log", @_);
}

sub fprInfo
{
  _fout("info", @_) if ($opt_v >= 1);
}

sub prInfo
{
  _out("info", @_) if ($opt_v >= 1);
}

sub prDebug
{
  _out("debug", @_) if ($opt_v >= 2);
}


sub _fout
{
  my @caller = caller 2;
  my $sub = defined $caller[3] ? $caller[3] : "main";
  $sub =~ s/main:://;

  my $level = shift @_;
  my $fmt   = shift @_;

  printf STDERR "[fe|%s|%s|%10d] ", $sub, $level, time();
  printf STDERR $fmt, @_;
}


sub _out
{
  my @caller = caller 2;
  my $sub = defined $caller[3] ? $caller[3] : "main";
  $sub =~ s/main:://;

  my $level = shift @_;

  my $prefix = sprintf "[fe|%s|%s|%10d] ", $sub, $level, time();

  foreach my $line (split /\n/, join("", @_)) {
    next if ($line =~ /^\s*$/);
    print STDERR $prefix;
    print STDERR $line;
    print STDERR "\n";
  }
}

1;
