# =============
# QPACE/TNWTEST
# =============
# $Id: lnk.pm 3149 2010-02-03 18:17:22Z pleiter $
#---------------------------------------------------------------------------------------------------

package Lnk;

use strict;

#---------------------------------------------------------------------------------------------------
# Constructor
#---------------------------------------------------------------------------------------------------

sub new
{
  my $class = shift;
  my @argv  = @_;

  my $self           = {};
  $self->{endpoint0} = undef;
  $self->{endpoint1} = undef;

  if (scalar @argv == 2 && ref($argv[0]) eq "Endpoint" && ref($argv[1]) eq "Endpoint") {
    $self->{endpoint0} = $argv[0];
    $self->{endpoint1} = $argv[1];
  }
  else {
    die "Contructor for class Link failed";
  }

  bless ($self, $class);
  return $self;
}


#---------------------------------------------------------------------------------------------------
# Member functions
#---------------------------------------------------------------------------------------------------

sub endpoint
{
  my $self = shift;
  my $i = shift;
  return \$self->{endpoint0} if ($i == 0);
  return \$self->{endpoint1} if ($i == 1);
  return undef;
}


sub as_string
{
  my $self = shift;
  return sprintf "%s %s", $self->{endpoint0}->as_string,
                          $self->{endpoint1}->as_string;
}

1;
